
function init()
	-- Registers tool
	RegisterTool("tisinuke", "Nuclear Strike", "MOD/vox/airstrike.vox")
	SetBool("game.tool.tisinuke.enabled", true)
	SetString("game.tool.tisinuke.ammo.display","")
	
    dubbySND = LoadLoop("MOD/snd/dubby.ogg")
    playedTime = 0
    animrec = 0
    maxanim = 0
    cooldown = 0
    recoil = 0	
	
	-- Handles airborne shells from time between firing to impact
	airstrikeprojectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active=false}
	}
	
	-- Populates airstrikeprojectileHandler with inactive shells
	for i=1, 250 do
		airstrikeprojectileHandler.shells[i] = deepcopy(airstrikeprojectileHandler.defaultShell)
	end
	
	-- Sets projectile properties
	velocity = 0.5
	shotDelay = 0.05
	
	-- Setup no cooldown if required
	nocd = GetBool("savegame.mod.nocd")
	
	-- Setup inverted mouse if required
	invertedMouse = 1
	if GetBool("savegame.mod.invert") then
		invertedMouse = 1
		else
		invertedMouse = 1
	end

	-- Setup shockwave size
	desiredSize = math.floor(GetInt("savegame.mod.desiredSize")/10 + (0 or .5))

	-- Sets initial weapon state
	flycamenabled = false
	airstrikeenabled = false
	firing = false
	radioactivated = false
	selectedshell = 4
	zoomlevel = 6
	maxzoom = 12
	minzoom = 0.5
	shockwaveSize = 0

	-- Initialise timers (shot timers)
	lightTimer = 0
	flashTimer = 0
	flashTimer2 = 0
	equipTimer = 0
	shoottimers = {}
	for i=1, 4 do
		shoottimers[i] = 0
	end

	-- Initialise projectile images
	shellsprites = {}
	shellsprites[1] = LoadSprite("MOD/img/25mm.png")
	shellsprites[2] = LoadSprite("MOD/img/40mm.png")
	shellsprites[3] = LoadSprite("MOD/img/gypsy.png")
	shellsprites[4] = LoadSprite("MOD/img/nuke.png")

	-- Initialise aircraft and gun sounds
	planesound = LoadLoop("MOD/snd/planeloop.ogg")
	switchsound = LoadSound("MOD/snd/switch.ogg")
	beepsound = LoadSound("MOD/snd/radiobeep.ogg")
	triggersound = LoadSound("MOD/snd/rocketcome.ogg")
	
	gunsounds = {}
	gunsounds[1] = LoadLoop("MOD/snd/gun1.ogg")
	gunsounds[2] = LoadSound("MOD/snd/gun2.ogg")
	gunsounds[3] = LoadSound("MOD/snd/gun3.ogg")
	gunsounds[4] = LoadSound("MOD/snd/rocket.ogg")
	
	-- Initialise projectile hit sounds
	bulletHit = {}
	bulletHit[1] = LoadLoop("MOD/snd/bullethit1.ogg",10)
	bulletHit[2] = LoadSound("MOD/snd/bullethit2.ogg",10)
	bulletHit[3] = LoadSound("MOD/snd/bullethit3.ogg",10)
	bulletHit[4] = LoadSound("MOD/snd/bullethit4.ogg",10)
	bulletHit[5] = LoadSound("MOD/snd/bullethit5.ogg"),10	
	
	nukeExplosion = LoadSound("MOD/snd/nukeExplosion.ogg", 999)
	nukeExplosion2 = LoadSound("MOD/snd/reccs.ogg", 60)
	
	--Initialise crew voices and set voice option
	voicesOn = GetBool("savegame.mod.voicesOn")
	
	if voicesOn then
		VoiceInit = {}
		VoiceInit[1] = LoadSound("MOD/vce/int/cleanupthatsignal.ogg")
		VoiceInit[2] = LoadSound("MOD/vce/int/highlightreel.ogg")
		VoiceInit[3] = LoadSound("MOD/vce/int/recalibrate.ogg")
		VoiceInit[4] = LoadSound("MOD/vce/int/setscanrange.ogg")
		VoiceInit[5] = LoadSound("MOD/vce/int/standbytoengage.ogg")
		VoiceInit[6] = LoadSound("MOD/vce/int/starttalking.ogg")
		VoiceInit[7] = LoadSound("MOD/vce/int/targetreset.ogg")
		VoiceInit[8] = LoadSound("MOD/vce/int/tracking.ogg")
		
		VoiceFire = {}
		VoiceFire[1] = LoadSound("MOD/vce/fre/affirmative.ogg",10)
		VoiceFire[2] = LoadSound("MOD/vce/fre/copy.ogg",1)
		VoiceFire[3] = LoadSound("MOD/vce/fre/itsshot.ogg",1)
		VoiceFire[4] = LoadSound("MOD/vce/fre/lightemup.ogg",1)
		VoiceFire[5] = LoadSound("MOD/vce/fre/takethemout.ogg",1)
		VoiceFire[6] = LoadSound("MOD/vce/fre/rogerthat.ogg")
		
		VoiceHit = {}
		VoiceHit[1] = LoadSound("MOD/vce/hit/directhits.ogg")
		VoiceHit[2] = LoadSound("MOD/vce/hit/kaboom.ogg")
		VoiceHit[3] = LoadSound("MOD/vce/hit/nice.ogg")
		VoiceHit[4] = LoadSound("MOD/vce/hit/rightontarget.ogg")
		VoiceHit[5] = LoadSound("MOD/vce/hit/thatsahit.ogg")
		VoiceHit[6] = LoadSound("MOD/vce/hit/whoa.ogg")
		VoiceHit[7] = LoadSound("MOD/vce/hit/yougotem.ogg")
	end

	-- Sets aircraft state
	plane = {}
	plane.pos = Vec(0, 0 ,0)
	plane.pos[1] = 65
	plane.pos[2] = 65
	plane.rot = QuatRotateQuat(Quat(), QuatEuler(-90, -90, 0))
	plane.barrel = {}
	plane.barrel.rot = Quat()
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -150))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function GetCamLookPos()
	local forwardPos = TransformToParentPoint(plane.barrel, Vec(0, 0, -150))
    local direction = VecSub(forwardPos, plane.barrel.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(plane.barrel.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(plane.barrel, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function GetShootDistance()
    local direction = VecSub(aimpos, plane.barrel.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(plane.barrel.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(plane.barrel, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return distance
end

-- Controls FlyCam movement when called every tick(dt)
function FlyCam()
	local mousewheel = InputValue("mousewheel")
	if mousewheel ~= 0 then
		zoomlevel = clamp(zoomlevel - mousewheel/2, minzoom, maxzoom)
	end

	local mx, my = InputValue("mousedx"), invertedMouse*InputValue("mousedy")

	local rotdiv = 200/zoomlevel
	if planevox ~= 0 then rotdiv = rotdiv * 2 end

	local CameraRot = QuatLookAt(plane.barrel.pos, aimpos)
	CameraRot = QuatRotateQuat(CameraRot, QuatEuler(-my/rotdiv, -mx/rotdiv, 0))
	plane.barrel.rot = CameraRot

	local newT = Transform(plane.barrel.pos, CameraRot)
	SetCameraTransform(newT, zoomlevel*10)
	SetPlayerTransform(GetPlayerTransform())
	PlayLoop(planesound, GetCameraTransform().pos, 1)
end

-- Controls shooting, called every tick(dt) when firing
function Shoot()
	if shoottimers[selectedshell] > 0 then
		return
	end

	local distance = GetShootDistance()
	local barrelEnd = TransformToParentPoint(plane.barrel, Vec(0, -1, -2))
	local dir = VecSub(aimpos, barrelEnd)

	airstrikeprojectileHandler.shells[airstrikeprojectileHandler.shellNum] = deepcopy(airstrikeprojectileHandler.defaultShell)
	loadedShell = airstrikeprojectileHandler.shells[airstrikeprojectileHandler.shellNum]
	loadedShell.active = true
	loadedShell.pos = barrelEnd
	loadedShell.cannonLoc = plane.barrel
	loadedShell.type = selectedshell
	loadedShell.predictedBulletVelocity = VecScale(dir, velocity)
	airstrikeprojectileHandler.shellNum = (airstrikeprojectileHandler.shellNum%#airstrikeprojectileHandler.shells) +1

	-- Shottimers
	if nocd then
		-- Without cooldown
		if selectedshell == 2 or selectedshell == 3  or selectedshell == 4 then
			shoottimers[selectedshell] = shotDelay * selectedshell
		else
			shoottimers[selectedshell] = shotDelay
		end
	else
		-- With cooldown
		if selectedshell == 1 then
			shoottimers[selectedshell] = shotDelay
		elseif selectedshell == 2 then
			shoottimers[selectedshell] = shotDelay * 7
		elseif selectedshell == 3 then
			shoottimers[selectedshell] = shotDelay * 50
		elseif selectedshell == 4 then
			shoottimers[selectedshell] = shotDelay * 50
			-- Plays trigger beep for nuke, only when cooldown is enabled
			if flycamenabled == false then 
				PlaySound(triggersound, GetCameraTransform().pos, 10)
			end
			
			if flycamenabled and voicesOn then
				local randomNumber = (Round(math.random(1,10),0,0))
				if randomNumber <= 6 then
					PlaySound(VoiceFire[randomNumber],GetCameraTransform().pos,0.8)
				end
			end
		end
	end
	
	if selectedshell ~= 1 then PlaySound(gunsounds[selectedshell], plane.barrel.pos, 0.5) end
	
	lightTimer = 0.05
end

function rnd(mi, ma)
    return math.random(0, 100)/100*(ma-mi)+mi
end

function rndVec(transformo, disto)
	maxc = math.random(1, max * 2)
    local v = VecNormalize(Vec(math.random(transformo[1] - maxc ,transformo[1] + maxc), transformo[2], transformo[3]))
    return VecScale(v, disto)  
end

function ProjectileOperations(projectile, dt)

    projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity,(VecScale(Vec(0, 0, 0), dt)))
    local point2 = VecAdd(projectile.pos,VecScale(projectile.predictedBulletVelocity,dt))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
    local hit, dist1 = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
	-- If projectile hits something, then starts process of doing damage
    if hit then 
	
		-- Determine the hit position and remove flying projectile
        hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2,projectile.pos)),dist1))
		projectile.active = false
		
		-- If hit with 25mm projectile
		if projectile.type == 1 then
			local randomSound = math.random(1,5)	
			MakeHole(hitPos, 1, 0.85, 0.7)
			PlaySound(bulletHit[randomSound], hitPos)
			SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), 1.5, 1.5)
			
		-- If hit with 40mm projectile
		elseif projectile.type == 2 then
			Explosion(hitPos, 1.5)
			
		-- If hit with Gypsy Shell (240mm) projectile	
		elseif projectile.type == 3 then
			local interval = 360 / 9
			for degrees = 1, 360, interval do
				local x = hitPos[1] + 5 * math.sin(degrees) 
				local z = hitPos[3] + 5 * math.cos(degrees)
				local hitPosition = Vec(x, hitPos[2],z)				
				--Explosion(hitPosition, 6)
			end
			--Explosion(hitPos, 4)
			
		-- If hit with Nuclear Missile
		elseif projectile.type == 4 then	
		
	        max = 30
	        if cooldown == 0 then
		        giveanim = true
	            cooldown = 25
	            maxanim = 25
	        end
            --pos = VecAdd(t.pos, VecScale(transform, dist))
            --breakpos = VecAdd(t.pos, rndVec(transform, dist))
            --if math.random(1, 5) == 3 then MakeHole(hitPosition, 0.1, 0.1, 0.1) end
            local objectbodies = QueryAabbBodies( VecAdd(hitPos, Vec(-max, -max, -max)), VecAdd(hitPos, Vec(max, max, max)))
            for i = 1, #objectbodies do
                local objectbodies2 = objectbodies[i]
                if IsBodyDynamic(objectbodies2) then
                  local bb, bbba = GetBodyBounds(objectbodies2)
                  local direction = VecSub(VecLerp(bb, bbba, 0.5), hitPos)
                  local distance = VecLength(direction)
                  direction = VecScale(direction, 1 / distance)
                  if distance < max and IsBodyVisible(objectbodies2, max * 100)then
                      local distScale = 1 - math.min(distance / max, 0.9)
                      local vel = GetBodyVelocity(objectbodies2)
                      vel = VecAdd(GetBodyVelocity(objectbodies2), VecScale(direction, 50 * distScale))
                      SetBodyVelocity(objectbodies2, vel)
                  end
                end
            end		
				
		    local interval = 360 / 9
			for degrees = 1, 360, interval do
				local x = hitPos[1] + 6 * math.sin(degrees) 
				local z = hitPos[3] + 6 * math.cos(degrees)
				local hitPosition = Vec(x, hitPos[2],z)				
				--Explosion(hitPosition, 1.5)
			end
			--Explosion(hitPos, 6)
		
			-- Play the sound effect
			PlaySound(nukeExplosion, hitPos, 1)
			PlaySound(nukeExplosion2, hitPos, 6)
		
			-- Play crew voice clip
			if flycamenabled and voicesOn then
				local randomNumber = (Round(math.random(1,10),0,0))
				if randomNumber <= 7 then
					PlaySound(VoiceHit[randomNumber],GetCameraTransform().pos,0.8)
				end
			end

			-- Start Explosion (including light flash and shockwave)
			Explosion(hitPos, 1)
			ShakeCamera(0.6)
			MakeHole(hitPos,4,4,4,"silent")
			flashTimer = 200
			flashTimer2 = 300
			shockwaveSize = desiredSize
						
			    PointLight(hitPos, 1, 0.5, 0.1, 5000)
				
				--wave
				ParticleReset()
        		ParticleRadius(4, 10, "smooth")
        		ParticleColor(1, 1, 1)
				ParticleTile(4)
        		--ParticleGravity(-0.05)
				ParticleAlpha(1, 0.0)
				ParticleStretch(0.0)
				ParticleCollide(0)
				--ParticleEmissive(0.1, 0)
                SpawnParticle(hitPos, Vec(0, 0, 0), 1.2)	

			    --swaveeadge
				ParticleReset()
                ParticleRadius(1, 4.5, "smooth")
                ParticleColor(0.7, 0.7, 0.7, 0.5, 0.5, 0.5)
                ParticleGravity(-0.03)
		        ParticleAlpha(0.4, 0)
		        ParticleStretch(40.0)
				ParticleCollide(0)
		        ParticleRotation(rnd(2,3), 0.0, "easeout")
		        ParticleDrag(0, 0.35)
		        for a=0, math.pi*55, 0.05 do
			        local x = math.cos(a)*10
			        local y = rnd(-0.1, 0.1)
			        local z = math.sin(a)*10
			        local d = VecNormalize(Vec(x, y, z))
			        SpawnParticle(VecAdd(hitPos, d), VecScale(d, rnd(0,30)), rnd(12, 17))
		        end		
				
                --mashroomtop1
				ParticleReset()
        		ParticleRadius(2, 9, "smooth")
        		ParticleColor(0.9, 0.9, 0.9, 0.7, 0.7, 0.7)
        		--ParticleGravity(-0.05)
				ParticleAlpha(1, 0.1)
				ParticleStretch(5.0)
				ParticleCollide(0)
				ParticleRotation(rnd(2,3), 0.5, "easeout")

        		for i=1,40 do
            		SpawnParticle(hitPos, Vec(rnd(-1.2,1.2), rnd(3.0,4.0), rnd(-1.2,1.2)), rnd(15,20))
        		end		
				
				--mashroomtop2
				ParticleReset()
        		ParticleRadius(2, 9, "smooth")
        		ParticleColor(0.8, 0.8, 0.8, 0.5, 0.5, 0.5)
        		--ParticleGravity(-0.05)
				ParticleAlpha(1, 0.1)
				ParticleStretch(0.0)
				ParticleCollide(0)
				ParticleRotation(rnd(-2,-3), -0.5, "easeout")

        		for i=1,40 do
            		SpawnParticle(hitPos, Vec(rnd(-1.2,1.2), rnd(3.0,4.0), rnd(-1.2,1.2)), rnd(15,20))
        		end		
				
				--mashroomtall
				ParticleReset()
        		ParticleRadius(2, 6, "smooth")
        		ParticleColor(0.8, 0.8, 0.8, 0.6, 0.6, 0.6)
        		--ParticleGravity(-0.1)
				ParticleAlpha(1, 0.1)
				ParticleStretch(1.0)
				ParticleCollide(0)
				ParticleRotation(rnd(1,2), 0.5, "easeout")
				--ParticleDrag(0, 0.1)

        		for i=1,45 do
            		SpawnParticle(hitPos, Vec(rnd(-0.2,0.2), rnd(0,3.5), rnd(-0.2,0.2)), rnd(15,20))
        		end		
				
                --mashroomland
				ParticleReset()
        		ParticleRadius(2.2, 8, "smooth")
        		ParticleColor(0.9, 0.9, 0.9, 0.6, 0.6, 0.6)
        		ParticleGravity(-0.05)
				ParticleAlpha(1, 0.1)
				ParticleStretch(0.0)
				ParticleCollide(0)
				ParticleRotation(rnd(1,2), 0.5, "easeout")
				ParticleDrag(0, 0.1)

        		for i=1,22 do
            		SpawnParticle(hitPos, Vec(rnd(-1.6,1.6), rnd(0,1.4), rnd(-1.6,1.6)), rnd(15,20))
        		end	
				
				--mashroomland2
				ParticleReset()
        		ParticleRadius(2.2, 6, "smooth")
        		ParticleColor(0.8, 0.8, 0.8, 0.5, 0.5, 0.5)
        		ParticleGravity(-0.04)
				ParticleAlpha(1, 0.1)
				ParticleStretch(0.0)
				ParticleCollide(0)
				ParticleRotation(rnd(-1,2), -0.5, "easeout")
				ParticleDrag(0, 0.1)

        		for i=1,85 do
            		SpawnParticle(hitPos, Vec(rnd(-3.5,3.5), rnd(0,0.8), rnd(-3.5,3.5)), rnd(15,20))
        		end	
				
				--mashroomfire1
		        ParticleReset()
		        ParticleTile(5)
                ParticleRadius(3.0, 1.5, "smooth")
                ParticleColor(1, 0.35, 0.25, 1, 0.5, 0.3)
                --ParticleGravity(0, rnd(-6, 1))
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(20.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(1, 1.5), 1, "easeout")
	        	ParticleEmissive(rnd(6,7), 0, "easeout")

                for i=1,75 do
                    SpawnParticle(hitPos, Vec(rnd(-1,1), rnd(3.3,3.7), rnd(-1,1)), rnd(9,10))
                end	
				
                --mashroomfire2
	        	ParticleReset()
	        	ParticleTile(5)
                ParticleRadius(3.0, 1.5, "smooth")
                ParticleColor(1, 0.4, 0.3, 1, 0.8, 0.5)
                --ParticleGravity(0, rnd(-6, 1))
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(20.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(-1, -1.5), -1, "easeout")
	        	ParticleEmissive(rnd(6,7), 0, "easeout")

                for i=1,75 do
                     SpawnParticle(hitPos, Vec(rnd(-1,1), rnd(3.3,3.7), rnd(-1,1)), rnd(9,10))
                end		
				
                --mashroomfiretall1
	        	ParticleReset()
	        	ParticleTile(5)
                ParticleRadius(3.0, 2.0, "smooth")
                ParticleColor(1, 0.35, 0.25, 1, 0.5, 0.3)
        		ParticleGravity(-0.3)
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(5.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(1, 1.5), -1, "easeout")
	        	ParticleEmissive(rnd(5,6), 0, "easeout")

                for i=1,60 do
            		SpawnParticle(hitPos, Vec(rnd(-0.2,0.2), rnd(0,4), rnd(-0.2,0.2)), 8)
                end
				
				--mashroomfiretall2
				ParticleReset()
	        	ParticleTile(5)
                ParticleRadius(3.0, 2, "smooth")
                ParticleColor(1, 0.4, 0.3, 1, 0.8, 0.5)
        		ParticleGravity(-0.3)
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(5.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(-1, -1.5), -1, "easeout")
	        	ParticleEmissive(rnd(5,6), 0, "easeout")

                for i=1,60 do
            		SpawnParticle(hitPos, Vec(rnd(-0.2,0.2), rnd(0,4), rnd(-0.2,0.2)), 8)
                end
				
				--mashroomfireland1
	        	ParticleReset()
	        	ParticleTile(5)
                ParticleRadius(2.2, 1.7, "smooth")
                ParticleColor(1, 0.55, 0.45, 1, 0.5, 0.3)
        		ParticleGravity(-0.3)
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(5.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(1, 1.5), -1, "easeout")
	        	ParticleEmissive(rnd(3,4), 0, "easeout")

                for i=1,45 do
            		SpawnParticle(hitPos, Vec(rnd(-2.2,2.2), 1, rnd(-2.2,2.2)), 7)
                end
				
				--mashroomfireland2
				ParticleReset()
	        	ParticleTile(5)
                ParticleRadius(2.2, 1.7, "smooth")
                ParticleColor(1, 0.7, 0.6, 1, 0.8, 0.5)
        		ParticleGravity(-0.3)
	        	ParticleAlpha(1, 0)
	        	ParticleStretch(5.0)
				ParticleCollide(0)
	        	ParticleRotation(rnd(-1, -1.5), -1, "easeout")
	        	ParticleEmissive(rnd(3,4), 0, "easeout")

                for i=1,45 do
            		SpawnParticle(hitPos, Vec(rnd(-2.2,2.2), 1, rnd(-2.2,2.2)), 7)
                end
				
		end
	end
	
	-- Projectile smoke trail
	--SpawnParticle("smoke", projectile.pos, Vec(0, 0, 0), 0.15*projectile.type, 1)
	
	ParticleReset()
    ParticleRadius(0.35, 0.5, "smooth")
    ParticleColor(0.9, 0.9, 0.9)
    ParticleGravity(0)
	ParticleAlpha(0.7, 0)
	ParticleStretch(10.0)
	ParticleCollide(0)
	ParticleRotation(rnd(1, 1.5), -1, "easeout")
	SpawnParticle(projectile.pos, Vec(rnd(-0.3,0.3), rnd(0.3,0.3), rnd(-0.3,0.3)), 1.5)

	PointLight(projectile.pos, 1, 0.5, 0.1, 30)
	

	-- Draws image of projectile shape
	local width = 0.6
	local length = 1.3
	local rot = QuatLookAt(projectile.pos, point2)
	local spritepos = TransformToParentPoint(Transform(projectile.pos, rot), Vec(0, 0, -1))
	rot = QuatRotateQuat(rot, QuatEuler(-90, 0, 0))
	rot2 = QuatRotateQuat(rot, QuatEuler(180, 90, 180))
	local transform = Transform(spritepos, rot)
	local transform2 = Transform(spritepos, rot2)
	DrawSprite(shellsprites[projectile.type], transform, width, length, 1, 1, 1, 1, true, false)
	DrawSprite(shellsprites[projectile.type], transform2, width, length, 1, 1, 1, 1, true, false)
    projectile.pos = point2
end

-- One iteration of nuclear shockwave
function shockwave(hitPos,size)
	ParticleReset()
	ParticleRadius(0.1)
	ParticleAlpha(0.5,0, "smooth",0.1, 0.3)
	ParticleCollide(0.0)
	ParticleGravity(-0.2)
	
	local ring = desiredSize + 1 - size	
	local holeSize = 3.6
	local ringSpacing = 4
	local circumference = 2 * math.pi * ring * ringSpacing
	local interval = 360 / (circumference / holeSize)
	
	for degrees = 1, 360, interval do
		-- Base layer
		local x = hitPos[1] + ringSpacing * ring * math.sin(degrees)
		local y = hitPos[2]
		local z = hitPos[3] + ringSpacing * ring * math.cos(degrees)
		local hitMe = Vec(x,y,z)
		SpawnFire(hitMe)
		MakeHole(hitMe, holeSize+1, holeSize+1, holeSize+1, "silent") -- Base layer
		
		-- Add random scatter
		x = hitPos[1] + ringSpacing * ring * math.sin(degrees) * math.random(8,10) * 0.1
		y = hitPos[2]
		z = hitPos[3] + ringSpacing * ring * math.cos(degrees) * math.random(8,10) * 0.1
		hitMe = Vec(x,y,z)

		MakeHole(VecAdd(hitMe,Vec(0,holeSize,0)), holeSize, holeSize, holeSize, "silent") -- +1 layer
		MakeHole(VecAdd(hitMe,Vec(0,holeSize*2,0)), holeSize-2, holeSize-2, holeSize-2, "silent") -- +2 layer
		MakeHole(VecAdd(hitMe,Vec(0,-holeSize,0)), holeSize, holeSize, holeSize, "silent") -- -1 layer
		MakeHole(VecAdd(hitMe,Vec(0,-holeSize*2,0)), holeSize-2, holeSize-2, holeSize-2, "silent") -- -2 layer
		
		-- Shockwave particles
		--SpawnParticle(VecAdd(hitMe,Vec(0,1.5,0)), Vec(0,0,0), 6)
	end
	-- Sets shockwave to the next ring outwards
	shockwaveSize = shockwaveSize - 1
end
	
function tick(dt)

	-- Updates all airborne projectiles
	for key, shell in ipairs(airstrikeprojectileHandler.shells) do
		if shell.active then
			ProjectileOperations(shell, dt)
		end
	end

	if GetString("game.player.tool") == "tisinuke" and GetPlayerVehicle() == 0 then
		SetBool("game.input.locktool", flycamenabled)
		firing = InputDown("usetool")
		airstrikeenabled = true
		if equipTimer < 1 then
			equipTimer = equipTimer + dt * 2
		end

		if firing then
			Shoot()
			if selectedshell == 1 then PlayLoop(gunsounds[selectedshell], plane.barrel.pos, 0.4) end
		end

		--if InputPressed("R") then
			--PlaySound(switchsound, GetCameraTransform().pos, 0.4)
			--if selectedshell == 4 then selectedshell = 1 else selectedshell = selectedshell + 1 end
		--end

		-- Toggle between gun camera and first person view, and play sound when required
		if InputPressed("rmb") then 
			if flycamenabled then
			flycamenabled = not flycamenabled
			else 
			flycamenabled = not flycamenabled
			local randomNumber = (Round(math.random(1,10),0,0))
			if randomNumber <= 8 then
			--PlaySound(VoiceInit[randomNumber],GetCameraTransform().pos,0.8)
			end
			end
		end
		
		if InputPressed("esc") then flycamenabled = false end
		if flycamenabled then FlyCam() end
		
		-- Nuclear missile flash
		if flashTimer > 0 then
		    local r = VecAdd (hitPos, Vec(0, 3, 0))
			PointLight(r, 1, 0.37, 0.1, flashTimer*2)
			flashTimer = flashTimer - dt*40
		end
		
		if flashTimer2 > 0 then
		    local r = VecAdd (hitPos, Vec(0, 3, 0))
			PointLight(r, 1, 0.37, 0.1, flashTimer2*18)
			flashTimer2 = flashTimer2 - dt*30
		end		
		
		if flashTimer2 > 0 then
			--SetEnvironmentProperty("exposure", flashTimer2)
			flashTimer2 = flashTimer2 - dt*100
		end		
		
		-- Iterates shockwave for nuke
		if shockwaveSize > 0 then
			shockwave(hitPos,shockwaveSize)
		end
		
		aimpos = flycamenabled and GetCamLookPos() or GetAimPos()

		local b = GetToolBody()
		if b ~= 0 then
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.95, -0.6, -2.1))

			-- AC-130 muzzle flash
			if lightTimer > 0 then
				PointLight(plane.barrel.pos, 1, 1, 1, 1)
				lightTimer = lightTimer - dt
			end

			-- Sets radio hand controller properties
			if body ~= b then
				body = b
				local shapes = GetBodyShapes(b)
				radioshape = shapes[1]
				antennashape = shapes[2]
				planeshape = shapes[3]
				blinkshape = shapes[4]
				radiotransformation = GetShapeLocalTransform(radioshape)
				antennatransformation = GetShapeLocalTransform(antennashape)
				planetransformation = GetShapeLocalTransform(planeshape)
				blinktransformation = GetShapeLocalTransform(blinkshape)
			end
			
			if equipTimer > 1 and not radioactivated then
				--PlaySound(beepsound, GetCameraTransform().pos, 0.4)
				radioactivated = true
			end

			if radioactivated then
				SetShapeEmissiveScale(radioshape, 0.5)
			else
				SetShapeEmissiveScale(radioshape, 0)
			end

			if InputDown("lmb") then
				SetShapeEmissiveScale(blinkshape, 5)
			else
				SetShapeEmissiveScale(blinkshape, 0)
			end

			rt = TransformCopy(radiotransformation)
			rt.rot = QuatRotateQuat(rt.rot, QuatEuler(0, 0, -15))
			SetShapeLocalTransform(radioshape, rt)

			bt = TransformCopy(blinktransformation)
			bt.rot = QuatRotateQuat(bt.rot, QuatEuler(0, 0, -15))
			SetShapeLocalTransform(blinkshape, bt)

			-- Radio antenna
			at = TransformCopy(antennatransformation)
			at.pos = VecAdd(at.pos, Vec(0, equipTimer*0.4, 0))
			at.rot = QuatRotateQuat(at.rot, QuatEuler(0, 0, -15))
			SetShapeLocalTransform(antennashape, at)

			SetShapeLocalTransform(planeshape, TransformToLocalTransform(GetBodyTransform(GetToolBody()), plane))
		end

		planefwdpos = TransformToParentPoint(plane, Vec(-0.15, 0, 0))
		planerotation = QuatRotateQuat(plane.rot, QuatEuler(0, 0, 0.1))
		plane.pos = planefwdpos
		plane.rot = planerotation
		plane.barrel.pos = TransformToParentPoint(plane, Vec(2.5, 4.5, 0))
	else
		airstrikeenabled = false
		radioactivated = false
		equipTimer = 0
	end

	for i=1, #shoottimers do
		if shoottimers[i] > 0 then
			shoottimers[i] = shoottimers[i] - dt
		else
			shoottimers[i] = 0
		end
	end
end
function draw()
	-- Crosshairs and text for flycam
	if flycamenabled and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(UiCenter(), UiMiddle())
			UiColor(1, 1, 1, 0.5)
			UiAlign("center middle")
			local crosshairid = selectedshell > 4 and 2 or selectedshell
			UiImage("MOD/img/AC130crosshair3.png")
		UiPop()

		UiPush()
			UiTranslate(UiCenter(), UiMiddle()+UiMiddle()/2+100)
			UiColor(1, 1, 1)
			UiAlign("center")
			UiFont("regular.ttf", 40)
			if selectedshell ~= 3 and selectedshell ~= 4 or shoottimers[selectedshell] == 0 then
				UiText("Ready")
			else
				UiText(tostring(math.ceil(shoottimers[selectedshell])))
			end
		UiPop()
	end
	if airstrikeenabled and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(60, UiMiddle()+UiMiddle()/2)
			UiColor(0.4, 0.4, 0.4)
			UiAlign("left")
			UiFont("regular.ttf", 26)
			UiTextOutline(0,0,0,1,0.2)
			
            UiTranslate(0, 225)
			UiPush()
				UiColor(1, 1, 1)
				--UiText("R key: Change ammo")
				--UiTranslate(0, 60)
				UiText("RMB: Gun camera")
			UiPop()

			--UiTranslate(0, 70)
			--UiPush()
				--if selectedshell == 1 then UiColor(1, 1, 1) end
				--UiText("25mm Vulcan")
			--UiPop()

			--UiTranslate(0, 30)
			--UiPush()
				--if selectedshell == 2 then UiColor(1, 1, 1) end
				--UiText("40mm Bofors")
			--UiPop()

			--UiTranslate(0, 30)
			--UiPush()
				--if selectedshell == 3 then UiColor(1, 1, 1) end
				--UiText("240mm Howitzer")
			--UiPop()
			--UiTranslate(0, 30)
			--UiPush()
				--if selectedshell == 4 then UiColor(1, 1, 1) end
				--UiText("Nuclear Missile")
			--UiPop()
			--UiTranslate(0, 30)
			--UiPush()
		UiPop()
	end
end

--Number rounding utility
function Round(value, decimals, overflow)
	decimals = decimals or 0
	overflow = overflow or .5
	return math.floor((value + overflow) * 10 ^ decimals) / 10 ^ decimals
end

-- Number clamping utility
function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end