function init()
	nocd = GetBool("savegame.mod.nocd")
	invert = GetBool("savegame.mod.invert")
	voicesON = GetBool("savegame.mod.voicesOn")
end

function draw()
	UiImage("MOD/back.png")
	-- Cooldown on/off button
	UiTranslate(UiCenter(), 150)
	UiAlign("center middle")

	UiFont("bold.ttf", 48)
	UiText("Nuclear Strike Options")
	UiFont("regular.ttf", 26)
	UiTranslate(0, 70)
	UiPush()
		--UiText("No Cooldown")
		UiTranslate(-20, 35)
		UiAlign("centre")
		UiColor(0.9, 0.7, 0.5)
	UiTranslate(20,50)
	
		
	--Nuclear Shockwave Size Slider
	UiPush()
		UiTranslate(-75,50)
		UiColor(1, 1, 1)
		UiText("  Shockwave Size")
		UiTranslate(0,40)
		local CurVal,MaxVal = optionsSlider("savegame.mod.desiredSize",0,100)
		UiTranslate(MaxVal+20,0)
		UiText(tostring(Round(CurVal/10,0,0)).."/"..tostring(MaxVal/10))
	UiPop()
	if GetInt("savegame.mod.desiredSize") > 49 then
		UiPush()
		UiTranslate(-200,120)
		UiColor(1, 0, 0)
		UiText("Large shockwaves will cause significant lag!")
		UiPop()
	end
	
	if GetInt("savegame.mod.desiredSize") < 9 then
		UiPush()
		UiTranslate(-200,120)
		UiColor(1, 1, 1)
		UiText("The shockwave only affects dynamic objects!")
		UiPop()
	end	
	
	if GetInt("savegame.mod.desiredSize") > 89 then
		UiPush()
		UiTranslate(-60,150)
		UiColor(1, 0, 0)
		UiText("Are you crazy?")
		UiPop()
	end
	
	--Close Menu Button
	UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
	UiTranslate(-20, 210)
	if UiTextButton("Close", 80, 40) then
		Menu()
	end
end

--Bespoke Slider for Atomic AC-130 Options
function optionsSlider(key,min,max)
	UiPush()
		UiTranslate(min,-8)
		local rv = GetInt(key)
		if (rv > max) then
			SetInt(key,max)
			rv = max
		elseif (rv < min) then
			SetInt(key,min)
			rv = min
		end
		UiRect(max-min,3)
		UiAlign("center middle")
		UiTranslate(-min,-8)
		local nsv,done = UiSlider("ui/common/dot.png","x",rv,min,max)
		if (nsv ~= rv) then
			if (nsv == 0) then
				SetInt(key,1) -- Cannot be zero.
			else
				SetInt(key,nsv)
			end
		end
	UiPop()
	return rv,max
end

--Simple maths rounding function for options slider
function Round(value, decimals, overflow)
	decimals = decimals or 0
	overflow = overflow or .5
	return math.floor((value + overflow) * 10 ^ decimals) / 10 ^ decimals
end